/* 
 * File:   debugcounter.h
 * Author: trbot
 *
 * Created on September 27, 2015, 4:43 PM
 */

#ifndef DEBUGCOUNTER_H
#define	DEBUGCOUNTER_H

#ifndef MEM_CONTEND_UNIT_WORDS
#define MEM_CONTEND_UNIT_WORDS 8
#endif

class debugCounter {
private:
    const int NUM_PROCESSES;
    volatile long long * data; // data[tid*8] = count for thread tid (padded to avoid false sharing)
public:
    void add(const int tid, const long long val) {
        data[tid*MEM_CONTEND_UNIT_WORDS] += val;
    }
    void inc(const int tid) {
        add(tid, 1);
    }
    long long get(const int tid) {
        return data[tid*MEM_CONTEND_UNIT_WORDS];
    }
    long long getTotal() {
        long long result = 0;
        for (int tid=0;tid<NUM_PROCESSES;++tid) {
            result += get(tid);
        }
        return result;
    }
    void clear() {
        for (int tid=0;tid<NUM_PROCESSES;++tid) {
            data[tid*MEM_CONTEND_UNIT_WORDS] = 0;
        }
    }
    debugCounter(const int numProcesses) : NUM_PROCESSES(numProcesses) {
        data = new long long[numProcesses*MEM_CONTEND_UNIT_WORDS];
        clear();
    }
    ~debugCounter() {
        delete[] data;
    }
};

#endif	/* DEBUGCOUNTER_H */

